
{% extends "main.html" %}
{% block title %}☄️ website{% endblock %}
{% block head %}
{{ super() }}
{% endblock %}
{% block content %}
<div class="container">
  <br>
<p class="h3" style="text-align: center;">☄ Meteor: cryptographically secure steganography for realistic distributions ☄</p>
</div>
<div class='container'>
			<div id="instructions">
                <p class="h4">Instructions:</p>
				1) Set the initialization key (mashing the keyboard is fine)<br>
				2) Write a context. Pick whatever subject and write some lines about it.<br>
				3) Pick a precision. High precision means better bitrate encoding, but more prone to errors. Low precision is the opposite.<br>
				4a) For encoding, write your text in the text area in the bottom right.<br>
				4b) For decoding, copy paste the generated stegotext into the top right text area. Whitespaces (if any) before letters included.<br>
				5) Press the appropriate button and wait some time, proportional to the amount of text to be computed.<br>
				6) The system will inform about the result, and the generated text will be appended.<br>
				Model and device-kind are chosen as environment variables, and are not manipulable during runtime.<br>
            </div>
			<hr>
    <div class="row align-items-start">
        <div class="col border-end">
            <div class="form-group">
                <label for="initkey">Initialization key</label>
                <input type="string" class="form-control" aria-label="initkey" name="initkey" id="initkey">
            </div>
            <div class="form-group">
                <label for="encrypted">Context</label>
                <textarea class="form-control" aria-label="context" name="context" id="context"></textarea>
            </div>
            <div class="form-group">
                <label for="precision" class="form-label">Precision</label>
                <input type="range" class="form-range" min="16" max="32" id="precision" value="32" oninput="this.nextElementSibling.value = this.value">
                <output>32</output>
            </div>

        </div>
        <div class="col">
            <div class="form-group">
                <label for="stegotext">Stegotext</label>
                <textarea class="form-control" style="height:300px" name="stegotext" id="stegotext"></textarea>
            </div>
            <br>
            <input type="button" class="btn btn-primary" value="Extract from stegotext" onclick="decode_text()" id="decode">
			<hr>
            <div class="form-group">
                <label for="encrypted">Text to be encrypted</label>
                <textarea class="form-control" style="height:200px" name="encrypted" id="encrypted"></textarea>
            </div>
			
            <input type="button" class="btn btn-primary" value="Generate stegotext" onclick="encode_text()" id="encode"><br>
        </div>

    </div>
    <hr>
    <div class="row align-items-start">
        <div class="col">
			<label for="input-file">Specify an encrypted file:</label>
            <input type="file" id="input-file"><br>
			<label for="input-file-cleartext">Specify a decrypted file:</label>
            <input type="file" id="input-file-cleartext"><br>
            <hr>
            <div id="explanation">
                <p class="h4">Results:</p> 
            </div>
            <div id="results"></div>
			<div id="response_server" style="border: blue;border-width: thick;border-style: solid;padding: 5px; white-space: pre-wrap"></div>
			<input type="button" class="btn btn-primary" value="Download the above text (if not empty)" onclick="saveTextAsFile()" id="download">
        </div>
    </div>
</div>
<script type="text/javascript">
document.getElementById('input-file')
  .addEventListener('change', getFile);
document.getElementById('input-file-cleartext')
  .addEventListener('change', getFile2);
function getFile(event) {
	const input = event.target
  if ('files' in input && input.files.length > 0) {
	  placeFileContent(
      document.getElementById('stegotext'),
      input.files[0])
  }
}
function getFile2(event) {
	const input = event.target
  if ('files' in input && input.files.length > 0) {
	  placeFileContent(
      document.getElementById('encrypted'),
      input.files[0])
  }
}

function placeFileContent(target, file) {
	readFileContent(file).then(content => {
  	target.value = content
  }).catch(error => console.log(error))
}

function readFileContent(file) {
	const reader = new FileReader()
  return new Promise((resolve, reject) => {
    reader.onload = event => resolve(event.target.result)
    reader.onerror = error => reject(error)
    reader.readAsText(file)
  })
}
    async function encode_text(){
        var parameters = [];
        parameters.push({name:'initkey' , value:document.getElementById('initkey').value});
        parameters.push({name:'context' , value:document.getElementById('context').value});
        parameters.push({name:'text_to_encode' , value:document.getElementById('encrypted').value});
        parameters.push({name:'precision' , value:document.getElementById('precision').value});
		document.getElementById('encode').disabled=true;
		document.getElementById('decode').disabled=true;
        $.ajax({
            url: 'encode',
            data: parameters,
            type: 'POST',
            success: function(response) {
			  document.getElementById('encode').disabled=false;
			  document.getElementById('decode').disabled=false;
              document.getElementById("response_server").innerHTML = response.message;
              document.getElementById("results").innerHTML = 'Encryption successful';

            },
            error: function(error) {
			  document.getElementById('encode').disabled=false;
			  document.getElementById('decode').disabled=false;
              document.getElementById("results").innerHTML = 'Something went wrong, try less data or adjust precision.';
            }
        });

    };
    async function decode_text(){
        var parameters = [];
        parameters.push({name:'initkey' , value:document.getElementById('initkey').value});
        parameters.push({name:'context' , value:document.getElementById('context').value});
        parameters.push({name:'text_to_decode' , value:document.getElementById('stegotext').value});
        parameters.push({name:'precision' , value:document.getElementById('precision').value});
		document.getElementById('encode').disabled=true;
		document.getElementById('decode').disabled=true;
        $.ajax({
            url: 'decode',
            data: parameters,
            type: 'POST',
            success: function(response) {
			  document.getElementById('encode').disabled=false;
			  document.getElementById('decode').disabled=false;
              document.getElementById("response_server").innerHTML = response.message;
              document.getElementById("results").innerHTML = 'Decryption successful';

            },
            error: function(error) {
			  document.getElementById('encode').disabled=false;
			  document.getElementById('decode').disabled=false;
              document.getElementById("results").innerHTML = 'Something went wrong, double check your text for starters.';
            }
        });

    }

function saveTextAsFile()
{
    var textToSave = document.getElementById("response_server").innerHTML;
	if (textToSave.length==0) return;
    var textToSaveAsBlob = new Blob([textToSave], {type:"text/plain"});
    var textToSaveAsURL = window.URL.createObjectURL(textToSaveAsBlob);
    var fileNameToSaveAs = "result.txt";
 
    var downloadLink = document.createElement("a");
    downloadLink.download = fileNameToSaveAs;
    downloadLink.innerHTML = "Download File";
    downloadLink.href = textToSaveAsURL;
    downloadLink.onclick = destroyClickedElement;
    downloadLink.style.display = "none";
    document.body.appendChild(downloadLink);
 
    downloadLink.click();
}
function destroyClickedElement(event)
{
    document.body.removeChild(event.target);
}
</script>
{% endblock %}
